
import java.util.*;

public class BinarySearchTree<E> extends AbstractSet<E> {

    protected TreeNode<E> root = null;
    protected int size = 0;

    protected static class TreeNode<E> {
        public E data;
        public TreeNode<E> left;
        public TreeNode<E> right;
        public TreeNode(E item) {
            data = item;
            left = null;
            right = null;
        }
    }

    public Iterator<E> iterator() {
        throw new UnsupportedOperationException("iterator() not implemented");
    }

    public int size() {
        return size;
    }

    @SuppressWarnings("unchecked")
    public boolean contains(Object item) {
        Comparable<? super E> itemCmp = (Comparable<? super E>) item;
        TreeNode<E> node = root;
        while (node != null) {
            int cmp = itemCmp.compareTo(node.data);
            if (cmp < 0) {
                node = node.left;
            } else if (cmp > 0) {
                node = node.right;
            } else {
                return true;
            }
        }
        return false;
    }

    @SuppressWarnings("unchecked")
    public boolean add(E item) {
        Comparable<? super E> itemCmp = (Comparable<? super E>) item;
        if (root == null) {
            root = new TreeNode<E>(item);
        } else {
            TreeNode<E> node = root;
            while (true) {
                int cmp = itemCmp.compareTo(node.data);
                if (cmp < 0) {
                    if (node.left == null) {
                        node.left = new TreeNode<E>(item);
                        break;
                    }
                    node = node.left;
                } else if (cmp > 0) {
                    if (node.right == null) {
                        node.right = new TreeNode<E>(item);
                        break;
                    }
                    node = node.right;
                } else {
                    return false;
                }
            }
        }
        size++;
        return true;
    }

}
